datetime prevTime[];
int shiftValue;

int GetLimit()
{
   int countedBars = IndicatorCounted();
   if (countedBars < 0)
      return (-1);
   return (Bars-countedBars-1);
}

void InitBuffers()
{
   ArrayCopySeries(prevTime,MODE_TIME);
}

void BeginCheckBuffers()
{
   if (ArraySize(prevTime) == 0)
      InitBuffers();

   shiftValue = 0;
   for(int i = ArraySize(prevTime)-1; i >= 0; i--)
   {
      if (prevTime[i] == Time[Bars-1])
         break;
      shiftValue++;
   }
}

void EndCheckBuffers()
{
   ArrayCopySeries(prevTime,MODE_TIME);
}

void CheckBuffer(double& buffer[])
{
   if (ArraySize(buffer) == 0)
   {
      ArrayResize(buffer,Bars);
      ArraySetAsSeries(buffer,true);
   }
   else
   {
      if (shiftValue>0)
      {
         ArrayResize(buffer,ArraySize(buffer)-shiftValue);
      }
      if (ArraySize(buffer) < Bars)
      {
         ArraySetAsSeries(buffer,false);
         ArrayResize(buffer,Bars);
         ArraySetAsSeries(buffer,true);
      }
   }
}

