#property indicator_separate_window
#property indicator_buffers 1
#property indicator_style1 DRAW_LINE
#property indicator_color1 White
#property indicator_width1 1

#include <IndOnline.mqh>

extern int FastPeriod = 9;
extern int SlowPeriod = 21;
extern int Signal = 5;

double OsMA[];
double MACD[];
double fast[];
double slow[];

double fa,sa;

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0, OsMA);
   SetIndexBuffer(1, MACD);
   SetIndexBuffer(2, fast);
   SetIndexBuffer(3, slow);
   SetIndexDrawBegin(0, Signal);
   IndicatorDigits(Digits + 2);
   string name = "D1m("+FastPeriod+","+SlowPeriod+","+Signal+")";
   IndicatorShortName(name);
   SetIndexLabel(0,name);
   
   fa = 2.0/(1.0+FastPeriod);
   sa = 2.0/(1.0+SlowPeriod);
   
   return(0);
}

int start()
{
   int limit = GetLimit();
   
   for (int i = limit; i >= 0; i--)
   {
      if (i == Bars-1)
      {
         fast[i] = Close[i];
         slow[i] = Close[i];
      }
      else
      {
         fast[i] = fa*Close[i]+(1.0-fa)*fast[i+1];
         slow[i] = sa*Close[i]+(1.0-sa)*slow[i+1];
      }
         
      MACD[i] = fast[i]-slow[i];
   }
   for(i = limit; i >= 0; i--)
   {
      double s = iMAOnArray(MACD, 0, Signal, 0, MODE_SMA, i);
      OsMA[i] = MACD[i] - s;
   }            
   return(0);
}

