#property indicator_separate_window
#property indicator_buffers 1
#property indicator_style1 DRAW_LINE
#property indicator_color1 LimeGreen
#property indicator_width1 1

#include <IndOnline.mqh>

extern int FastPeriod = 9;
extern int SlowPeriod = 55;
extern bool AutoParams = true;

int fastPeriod = 9;
int slowPeriod = 55;

double macd[];
double fast[];
double slow[];
double mFast[];
double mSlow[];

double fa,sa;

int init() 
{
   if (AutoParams)
   {
      switch(Period())
      {
      case PERIOD_M15:
      case PERIOD_D1:
      case PERIOD_W1:
      case PERIOD_MN1:
         fastPeriod = 7;                  
      }
   }
   else
   {
      fastPeriod = FastPeriod;
      slowPeriod = SlowPeriod;
   }

   IndicatorBuffers(5);
   SetIndexBuffer(0, macd);
   SetIndexBuffer(1, fast);
   SetIndexBuffer(2, slow);
   SetIndexBuffer(3, mFast);
   SetIndexBuffer(4, mSlow);
   SetIndexDrawBegin(0, slowPeriod);
   string name = "M2m("+fastPeriod+","+slowPeriod+")";
   IndicatorShortName(name);
   SetIndexLabel(0, name);

   fa = 2.0/(1.0+fastPeriod);
   sa = 2.0/(1.0+slowPeriod);

   return (0);
}

int start() 
{
   int limit = GetLimit();

   for (int i = limit; i >= 0; i--) 
   {
      if (i == Bars-1)
      {
         fast[i] = Close[i];
         slow[i] = Close[i];
      }
      else
      {
         fast[i] = fa*Close[i]+(1.0-fa)*fast[i+1];
         slow[i] = sa*Close[i]+(1.0-sa)*slow[i+1];
      }
   }
   for (i = limit; i >= 0; i--) 
   {
      if (i == Bars-1)
      {
         mFast[i] = fast[i];
         mSlow[i] = slow[i];
      }
      else
      {
         mFast[i] = fa*fast[i]+(1.0-fa)*mFast[i+1];
         mSlow[i] = sa*slow[i]+(1.0-sa)*mSlow[i+1];
      }
      double f = fast[i] + fast[i] - mFast[i];
      double s = slow[i] + slow[i] - mSlow[i];
      macd[i] = f - s;
   }
   return (0);
}