#property indicator_separate_window
#property indicator_buffers 1
#property indicator_style1 DRAW_LINE
#property indicator_color1 Magenta
#property indicator_width1 1

#include <IndOnline.mqh>

extern int FastPeriod = 5;
extern int SlowPeriod = 89;
extern double B = 0.7;
extern bool AutoParams = true;

int fastPeriod = 5;
int slowPeriod = 89;
double b = 0.7;

double macd[];
double fast[];
double slow[];

double fe1[],fe2[],fe3[],fe4[],fe5[],fe6[];
double se1[],se2[],se3[],se4[],se5[],se6[];

double c1,c2,c3,c4;
double fw1,fw2;
double sw1,sw2;


int init() 
{
   if (AutoParams)
   {
      switch(Period())
      {
      case PERIOD_M1:
      case PERIOD_M5:
      case PERIOD_M15:
      case PERIOD_M30:
      case PERIOD_H1:
         b = 0.7;
         break;
      case PERIOD_H4:
      case PERIOD_D1:
      case PERIOD_W1:
      case PERIOD_MN1:
         b = 1.0;
      }
   }
   else
   {
      fastPeriod = FastPeriod;
      slowPeriod = SlowPeriod;
      b = B;
   }
   IndicatorBuffers(3);
   SetIndexBuffer(0, macd);
   SetIndexDrawBegin(0,slowPeriod);
   SetIndexBuffer(1, fast);
   SetIndexBuffer(2, slow);
   IndicatorDigits(Digits+2);
   string name = "M3m("+fastPeriod+","+slowPeriod+","+DoubleToStr(b,1)+")";
   IndicatorShortName(name);
   SetIndexLabel(0, name);
   
   double b2=b*b;
   double b3=b2*b;
   c1=-b3;
   c2=(3*(b2+b3));
   c3=-3*(2*b2+b+b3);
   c4=(1+3*b+b3+3*b2);

   double n = 1 + 0.5*(fastPeriod-1);
   fw1 = 2 / (n + 1);
   fw2 = 1 - fw1;

   n = 1 + 0.5*(slowPeriod-1);
   sw1 = 2 / (n + 1);
   sw2 = 1 - sw1;

   return (0);
}

int start() 
{
   BeginCheckBuffers();
   CheckBuffer(fe1);
   CheckBuffer(fe2);
   CheckBuffer(fe3);
   CheckBuffer(fe4);
   CheckBuffer(fe5);
   CheckBuffer(fe6);
   CheckBuffer(se1);
   CheckBuffer(se2);
   CheckBuffer(se3);
   CheckBuffer(se4);
   CheckBuffer(se5);
   CheckBuffer(se6);
   EndCheckBuffers();
   
   int limit = GetLimit();

   T3(fastPeriod,fast,limit,
      fe1,fe2,fe3,fe4,fe5,fe6,
      fw1,fw2);
   T3(slowPeriod,slow,limit,
      se1,se2,se3,se4,se5,se6,
      sw1,sw2);
   for(int bar = limit; bar >= 0; bar--)
      macd[bar] = fast[bar]-slow[bar];
   return (0);
}

void T3(int period, double& buffer[], int limit, 
   double& e1[], double& e2[], double& e3[], double& e4[], double& e5[], double& e6[],
   double w1, double w2)
{
   int maxLimit = Bars-2;
   if (limit > maxLimit)
   {
      for(int bar=Bars-1; bar>maxLimit; bar--)
         buffer[bar]=0.0;
      limit=maxLimit;
      e1[Bars-1] = Close[Bars-1];
      e2[Bars-1] = Close[Bars-1];
      e3[Bars-1] = Close[Bars-1];
      e4[Bars-1] = Close[Bars-1];
      e5[Bars-1] = Close[Bars-1];
      e6[Bars-1] = Close[Bars-1];
   }
   for(bar=limit; bar>=0; bar--)
   {  
      e1[bar] = w1*Close[bar] + w2*e1[bar+1];
      e2[bar] = w1*e1[bar] + w2*e2[bar+1];
      e3[bar] = w1*e2[bar] + w2*e3[bar+1];
      e4[bar] = w1*e3[bar] + w2*e4[bar+1];
      e5[bar] = w1*e4[bar] + w2*e5[bar+1];
      e6[bar] = w1*e5[bar] + w2*e6[bar+1];

      buffer[bar]=c1*e6[bar] + c2*e5[bar] + c3*e4[bar] + c4*e3[bar];
   } 
}