#property link "http://www.tradersforum.net.ru/forum/balash-m3616.html"

extern int StopLoss = 70;

int SlipPage = 50;

#define SKFX "SKFX"
#define BUY "Buy"
#define SELL "Sell"
#define CLOSE "Close"
#define NO_LOSS "NoLoss"

int xB = 10, yB = 10;
int xS = 10, yS = 50;
int xC = 10, yC = 30;
int xN = 10, yN = 70;

bool needRefresh = true;

int init()
{
   Refresh();
}

int start()
{
   OpenOrder();
   CloseAll();
   MakeIndemnity();
   Refresh();
}

void OpenOrder()
{
   OpenBuy();
   OpenSell();
}

void OpenBuy()
{
   if (!WasMoved(BUY))
      return;
   OrderSend(Symbol(),OP_BUY,LotSize(),Ask,SlipPage,MakeStopLoss(OP_BUY),0);
}

void OpenSell()
{
   if (!WasMoved(SELL))
      return;
   OrderSend(Symbol(),OP_SELL,LotSize(),Bid,SlipPage,MakeStopLoss(OP_SELL),0);
}

void CloseAll()
{
   if (!WasMoved(CLOSE))
      return;
   for (int i = OrdersTotal() - 1; i >= 0; i--)
   {
      OrderSelect(i,SELECT_BY_POS);
      if (OrderType() == OP_BUY)
      {
         OrderClose(OrderTicket(),OrderLots(),Ask,SlipPage);
      }
      if (OrderType() == OP_SELL)
      {
         OrderClose(OrderTicket(),OrderLots(),Bid,SlipPage);
      }
   }
}

void MakeIndemnity()
{
   if (!WasMoved(NO_LOSS))
      return;
   for (int i = OrdersTotal() - 1; i >= 0; i--)
   {
      OrderSelect(i,SELECT_BY_POS);
      MakeIndemnityOrder();
   }
}

void MakeIndemnityOrder()
{
   if (
      (OrderType() == OP_BUY && Bid > OrderOpenPrice()+MarketInfo(Symbol(),MODE_STOPLEVEL)*Point)
      ||
      (OrderType() == OP_SELL && Ask < OrderOpenPrice()-MarketInfo(Symbol(),MODE_STOPLEVEL)*Point)
      )
   {
      if (!OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),OrderExpiration()))
      {
         Print("OrderModify ",GetLastError());
      }
   }
}

void Refresh()
{
   if (!needRefresh)
      return;
   RefreshObject(BUY,xB,yB,Aqua);
   RefreshObject(SELL,xS,yS,OrangeRed);
   RefreshObject(CLOSE,xC,yC,Yellow);
   RefreshObject(NO_LOSS,xN,yN,Lime);
   WindowRedraw();
   needRefresh = false;
}

void RefreshObject(string name, int x, int y, color c)
{
   string nm = SKFX + name;
   ObjectDelete(nm);
   ObjectCreate(nm,OBJ_LABEL,0,0,0);
   ObjectSet(nm,OBJPROP_CORNER,0);
   ObjectSet(nm,OBJPROP_XDISTANCE,x);
   ObjectSet(nm,OBJPROP_YDISTANCE,y);
   ObjectSetText(nm,StringSubstr(name,0,1),10,"Arial",c);
}


double LotSize()
{
   return (1);
}

bool WasMoved(string name)
{
   if (name == BUY)
   {
      return (WasMovedObject(name,xB,yB));
   }
   else if (name == SELL)
   {
      return (WasMovedObject(name,xS,yS));
   }
   else if (name == CLOSE)
   {
      return (WasMovedObject(name,xC,yC));
   }
   else if (name == NO_LOSS)
   {
      return (WasMovedObject(name,xN,yN));
   }
   return (false);
}

bool WasMovedObject(string name, int x, int y)
{
   bool result =
      x != ObjectGet(SKFX+name,OBJPROP_XDISTANCE)
      ||
      y != ObjectGet(SKFX+name,OBJPROP_YDISTANCE)
      ;
   if (GetLastError() == 4202) //   
   {
      needRefresh = true;
      return (false);
   }
   needRefresh = needRefresh || result;
   return (result);
}

double MakeStopLoss(int type)
{
   if (StopLoss == 0)
      return (0);
   if (type == OP_BUY)
      return (Bid-StopLoss*Point);
   else if (type == OP_SELL)
      return (Ask+StopLoss*Point);
   return (0);
}